
PopoHelperCommand = Turbine.ShellCommand();

------------------------------------------------------------------------------------------
-- commands
------------------------------------------------------------------------------------------
function PopoHelperCommand:Execute( command, arguments )

	local args, value = arguments:match "(mopourcent) (.*)";
	local args2, value2 = arguments:match "(popourcent) (.*)";
	
	if ( arguments == "help" ) then
		Turbine.Shell.WriteLine(Strings.PluginHelp);
	elseif ( arguments == "show" ) then
		--Turbine.Shell.WriteLine("Show the PopoHelper Window");
		PopoHelperWindow:SetVisible(true);
		settings.isWindowVisible = true;
		SaveSettings();
	elseif ( arguments == "hide" ) then
		--Turbine.Shell.WriteLine("Hide the PopoHelper Window");
		PopoHelperWindow:SetVisible(false);
		settings.isWindowVisible = false;
		SaveSettings();
	elseif ( arguments == "default" ) then
		Turbine.Shell.WriteLine(Strings.PluginName .. " : " .. Strings.PluginMorale .. " " .. Strings.PluginPourcent .. "20 %" .. Strings.PluginPourcent2);
		Turbine.Shell.WriteLine(Strings.PluginName .. " : " .. Strings.PluginPower .. " " .. Strings.PluginPourcent .. "20 %" .. Strings.PluginPourcent3);
		settings.moralPourcent = 20;
		settings.powerPourcent = 20;
		SaveSettings();
	elseif ( args == "mopourcent" ) then
		if(tonumber(value) >= 90) then
			value = 90;
		end
		Turbine.Shell.WriteLine(Strings.PluginName .. " : " .. Strings.PluginMorale .. " ".. Strings.PluginPourcent .. value .. " %" .. Strings.PluginPourcent2);
		settings.moralPourcent = value;
		SaveSettings();
	elseif ( args2 == "popourcent" ) then
		if(tonumber(value2) >= 90) then
			value2 = 90;
		end
		Turbine.Shell.WriteLine(Strings.PluginName .. " : " .. Strings.PluginPower .. " ".. Strings.PluginPourcent .. value2 .. " %" .. Strings.PluginPourcent3);
		settings.powerPourcent = value2;
		SaveSettings();
	elseif ( arguments == "clear" ) then
		--Turbine.Shell.WriteLine("clear the PopoHelper Window");
		settings.shortcutData_1 = tostring("");
		settings.shortcutData_2 = tostring(""); 
		settings.shortcutData_3 = tostring(""); 
		settings.shortcutData_4 = tostring(""); 
		centerQS1:SetShortcut(Turbine.UI.Lotro.Shortcut()); 
		centerQS2:SetShortcut(Turbine.UI.Lotro.Shortcut());
		centerQS3:SetShortcut(Turbine.UI.Lotro.Shortcut());
		centerQS4:SetShortcut(Turbine.UI.Lotro.Shortcut());
		SaveSettings();
	end
end

Turbine.Shell.AddCommand( "Popo;PopoHelper", PopoHelperCommand );