 import "Turbine.UI"; 
 import "Turbine.UI.Extensions"; 
 import "Turbine.UI.Lotro"; 
 import "Turbine.Gameplay"; 

 import "Homeopatix.PopoHelper.Globals"
 import "Homeopatix.PopoHelper.MinimizedIcon"
 import "Homeopatix.PopoHelper.VindarPatch"
 import "Homeopatix.PopoHelper.Commands"
 import "Homeopatix.PopoHelper.LoadAndSave"
 import "Homeopatix.PopoHelper.MainWindow"
 import "Homeopatix.PopoHelper.FCT"

Turbine.Shell.WriteLine("<rgb=#CC56DA>PopoHelper</rgb> <rgb=#DDDDDD>".. plugin:GetVersion() .." par Homeo</rgb>")

CreateLocalizationInfo();
LoadSettings();
------------------------------------------------------------------------------------------
-- create the main window
------------------------------------------------------------------------------------------
CreateMainWindow();

------------------------------------------------------------------------------------------
-- mouse click handler
------------------------------------------------------------------------------------------
MouseClickHandler();

------------------------------------------------------------------------------------------
-- setting the shortcuts
------------------------------------------------------------------------------------------
SetTheShortCuts();

------------------------------------------------------------------------------------------
-- setting the shortcuts for drag and drop
------------------------------------------------------------------------------------------
DragAndDrop();

------------------------------------------------------------------------------------------
-- delete the shortcut with mouse wheel
------------------------------------------------------------------------------------------
DeleteShortCuts();
        
------------------------------------------------------------------------------------------
-- Closing window handler
------------------------------------------------------------------------------------------
ClosingWindow();

------------------------------------------------------------------------------------------
-- handle minimizeIcon
------------------------------------------------------------------------------------------
if(settings.isWindowVisible == "true")then
	MainMinimizedIcon = MinimizedIcon(Images.MinimizedIcon, 32, 32, PopoHelperWindow:SetVisible(true));
else
	MainMinimizedIcon = MinimizedIcon(Images.MinimizedIcon, 32, 32, PopoHelperWindow:SetVisible(false));
end

MainMinimizedIcon:SetPosition(settings.minimizeX, settings.minimizeY);
MainMinimizedIcon:SetZOrder(0);
MainMinimizedIcon:SetWantsUpdates(true);
MainMinimizedIcon.PositionChanged = function()
	settings.minimizeX = MainMinimizedIcon:GetLeft();
	settings.minimizeY = MainMinimizedIcon:GetTop();
	SaveSettings();
end
------------------------------------------------------------------------------------------
-- checking life
------------------------------------------------------------------------------------------
MainMinimizedIcon.Update = function(sender, args)
	Player = Turbine.Gameplay.LocalPlayer.GetInstance();

	local life = Player:GetMorale();
	local maxLife = Player:GetMaxMorale();
	local class = Player:GetClass();
	
	local power = Turbine.Gameplay.LocalPlayer:GetInstance():GetPower();
	local maxPower = Turbine.Gameplay.LocalPlayer:GetInstance():GetMaxPower();
	
	local lifePourcent = settings.moralPourcent * maxLife / 100;
	local powerPourcent = settings.powerPourcent * maxPower / 100;
	
	if(class ~= 214) then
		-- show the window if the morale is under XX pourcent
		if(life <= lifePourcent and settings.isLifeUnderMoralPourcent == "false") then
			--Turbine.Shell.WriteLine("Life en dessous de " .. pourcent .. " pourcent");
			PopoHelperWindow:SetVisible(true);
			settings.isWindowVisible = true;
			settings.isLifeUnderMoralPourcent = true;
		elseif(life > lifePourcent) then
			settings.isLifeUnderMoralPourcent = false;
		end
	
		-- show the window if the Power is under XX pourcent
		if(power <= powerPourcent and settings.isPowerUnderPowerPourcent == "false") then
			--Turbine.Shell.WriteLine("Power en dessous de " .. pourcent .. " pourcent");
			PopoHelperWindow:SetVisible(true);
			settings.isWindowVisible = true;
			settings.isPowerUnderPowerPourcent = true;
		elseif(power > powerPourcent) then
			settings.isPowerUnderPowerPourcent = false;
		end
		
		PopoHelperWindow.Message3:SetText(Strings.PluginPower .. Strings.PluginPourcent .. settings.powerPourcent .. "%");
	else -- this is a beornide
			-- show the window if the morale is under XX pourcent
		if(life <= lifePourcent and settings.isLifeUnderMoralPourcent == "false") then
			--Turbine.Shell.WriteLine("Life en dessous de " .. pourcent .. " pourcent");
			PopoHelperWindow:SetVisible(true);
			settings.isWindowVisible = true;
			settings.isLifeUnderMoralPourcent = true;
		elseif(life > lifePourcent) then
			settings.isLifeUnderMoralPourcent = false;
		end
							
		PopoHelperWindow.Message3:SetText(Strings.PluginWrath .. "...");
	end
	
	PopoHelperWindow.Message2:SetText(Strings.PluginMorale .. Strings.PluginPourcent .. settings.moralPourcent .. "%");
	
	-- calcul pourcentage de vie
	local lifeInPourcent = life * 100 / maxLife;
	local powerInPourcent = power * 100 / maxPower;
	
	if(class ~= 214) then
		PopoHelperWindow.Message4:SetText(string.format("%.0f", lifeInPourcent) .. "%");
		PopoHelperWindow.Message5:SetText(string.format("%.0f", powerInPourcent) .. "%");
	else
		PopoHelperWindow.Message4:SetText(string.format("%.0f", lifeInPourcent) .. "%");
		PopoHelperWindow.Message5:SetText(Strings.PluginWrath .. "...");
	end
end

------------------------------------------------------------------------------------------
-- event handling
------------------------------------------------------------------------------------------
PopoHelperWindow.KeyDown=function(sender, args)
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		PopoHelperWindow:SetVisible(false);
		settings.isWindowVisible = false;
		settings.isLifeUnderPourcent = false;
		settings.isPowerUnderPourcent = false;
		SaveSettings();
	end
	
	-- https://www.lotro.com/forums/showthread.php?493466-How-to-hide-a-window-on-F12&p=6581962#post6581962
	if ( args.Action == 268435635 ) then
		hudVisible=not hudVisible;
		if hudVisible then
			PopoHelperWindow:SetVisible(false);
			MainMinimizedIcon:SetVisible(false);
		else
			PopoHelperWindow:SetVisible(settings.isWindowVisible);
			MainMinimizedIcon:SetVisible(true);
		end
	end
end
------------------------------------------------------------------------------------------
-- if the position changes, save the new window location
------------------------------------------------------------------------------------------
	PopoHelperWindow.PositionChanged = function( sender, args )
    	local x,y = PopoHelperWindow:GetPosition();
    	settings.positionX = x;
    	settings.positionY = y;
		SaveSettings();
	end